10 REM TNC.BAS   Brad Killebrew N5LJV    28-JUN-94   VER 1.3a
20 REM RELEASED TO PUBLIC DOMAIN ON 29-JUL-94
25 REM THIS VERSION WAS LAST UPDATED ON 30-JUL-94
30 COLOR 15: VERS$ = "1.3a"
40 PRINT : PRINT "TNCset Time Set Utility"
50 PRINT "By Brad Killebrew N5LJV  Ver "; VERS$
60 REM ** DEFAULT SETTINGS ***
70 C$ = "4": B$ = "9600": P$ = "N": D$ = "8": S$ = "1"
120 GOSUB 860
130 REM ** CREATE A TNC RECOGNIZABLE TIME STRING **
140 TNC$ = STRING$(12, CHR$(32))
150 MID$(TNC$, 1, 2) = RIGHT$(DATE$, 2)
160 MID$(TNC$, 3, 2) = LEFT$(DATE$, 2)
170 MID$(TNC$, 5, 2) = MID$(DATE$, 4, 2)
180 MID$(TNC$, 7, 2) = LEFT$(TIME$, 2)
190 MID$(TNC$, 9, 2) = MID$(TIME$, 4, 2)
200 TSS = VAL(RIGHT$(TIME$, 2))
210 IF TSS < 9 THEN TSS$ = "0" + RIGHT$(STR$(TSS + 1), 1): GOTO 230
220 TSS$ = RIGHT$(STR$(TSS + 1), 2)
230 MID$(TNC$, 11, 2) = TSS$
240 V$ = C$ + ": " + B$ + "," + P$ + "," + D$ + "," + S$ + " > NUL"
250 TCOM$ = " > COM" + C$ + ":"
260 BKSP$ = STRING$(5, CHR$(8))
270 REM ** CREATE TIME-SET BATCH FILE **
280 OPEN "TNCSET.BAT" FOR OUTPUT AS #1
290 PRINT #1, ": TNCSET.BAT"
300 PRINT #1, "@ECHO OFF"
310 PRINT #1, "MODE COM" + V$
320 PRINT #1, "ECHO " + BKSP$ + "DAY " + TNC$ + TCOM$
330 PRINT "Sending Command:  DAY "; TNC$: PRINT : END
340 REM ** NO CONFIG FILE FOUND - LET'S MAKE ONE **
350 COLOR 4: PRINT : PRINT CHR$(7);
360 PRINT "Configuration file not found.": PRINT
370 COLOR 15: PRINT "Would you like to create a configuration file? (Y/N) >";
380 GOSUB 820: IF YN = 1 THEN GOTO 400
390 PRINT : PRINT "Program terminated.": END
400 PRINT : PRINT "You will be asked several questions that pertain"
410 PRINT "to your TNC configuration."
420 PRINT : PRINT "You can terminate the program at any time by typing END."
430 PRINT : PRINT "At what baud rate do you communicate with your TNC?"
440 PRINT "Choices: 300, 1200, 2400, 4800, 9600."
450 PRINT : PRINT "Enter baud rate >"; : GOSUB 800: B$ = IP$
460 IF B$ = "300" OR B$ = "1200" OR B$ = "2400" OR B$ = "4800" OR B$ = "9600" GOTO 480
470 GOSUB 770: GOTO 430
480 PRINT : PRINT "What COM port is your TNC connected to?"
490 PRINT "Choices: 1, 2, 3, or 4."
500 PRINT : PRINT "Enter COM port number >"; : GOSUB 800: C$ = IP$
510 C = VAL(C$): IF C > 0 AND C < 5 THEN 530
520 GOSUB 770: GOTO 480
530 PRINT : PRINT "Normal settings for TNC communications are:"
540 PRINT "NO parity, 8 data bits, and 1 stop bit."
550 PRINT : PRINT "Change the defaults? (Y/N) >"; : GOSUB 820
560 IF YN = 0 THEN GOTO 720
570 PRINT : PRINT "Please select parity."
580 PRINT "Choices: (N)ONE, (E)VEN, (O)DD."
590 PRINT : PRINT "Enter parity (N,E,O) >"; : GOSUB 800: P$ = IP$
600 IF P$ = "N" OR P$ = "n" OR P$ = "E" OR P$ = "e" OR P$ = "O" OR P$ = "o" THEN 620
610 GOSUB 770: GOTO 570
620 PRINT : PRINT "Please select data bits."
630 PRINT "Choices: 7 or 8."
640 PRINT : PRINT "Enter data bits (7,8) >"; : GOSUB 800: D$ = IP$
650 IF D$ = "7" OR D$ = "8" THEN 670
660 GOSUB 770: GOTO 620
670 PRINT : PRINT "Please select stop bits."
680 PRINT "Choices: 0 or 1."
690 PRINT : PRINT "Enter stop bits (0,1) >"; : GOSUB 800: D$ = IP$
700 IF D$ = "0" OR D$ = "1" THEN GOTO 720
710 GOSUB 770: GOTO 670
720 COLOR 14: PRINT : PRINT "Configuration file created successfully."
730 PRINT : PRINT "TNCset will now attempt to set the TNC's internal clock."
740 PRINT "Make sure the TNC is turned on and ready for input signals."
750 PRINT : LINE INPUT "Press ENTER when ready ..."; Z$
760 COLOR 15: GOSUB 950: GOTO 10
770 COLOR 4: PRINT : PRINT CHR$(7); "Error in data input.": COLOR 15
780 PRINT "Please check your choices and try again.": RETURN
790 REM ** KEYBOARD INPUT (STRING) **
800 LINE INPUT IP$: IF IP$ = "END" OR IP$ = "end" THEN END ELSE RETURN
810 REM ** KEYBOARD INPUT (YES OR NO) **
820 LINE INPUT YN$: YN$ = LEFT$(YN$, 1)
830 IF YN$ = "END" OR YN$ = "end" THEN PRINT : END
840 IF YN$ = "y" OR YN$ = "Y" THEN YN = 1 ELSE YN = 0
850 RETURN
860 REM ** READ CONFIG FILE **
870 CLOSE : ON ERROR GOTO 350
880 OPEN "TNC.INI" FOR INPUT AS #1
890 LINE INPUT #1, C$(1): C$ = RIGHT$(LEFT$(C$, 1), 1)
900 LINE INPUT #1, B$(2): B$ = LEFT$(B$, 4)
910 LINE INPUT #1, P$(3): P$ = LEFT$(P$, 1)
920 LINE INPUT #1, D$(4): D$ = RIGHT$(LEFT$(D$, 1), 1)
930 LINE INPUT #1, S$(5): S$ = RIGHT$(LEFT$(S$, 1), 1)
940 CLOSE #1: RETURN
950 REM ** WRITE CONFIG FILE **
960 CLOSE : OPEN "TNC.INI" FOR OUTPUT AS #1
970 PRINT #1, C$ + "       <=== COM PORT (1,2,3,4)"
980 PRINT #1, B$ + "    <=== BAUD RATE (300,1200,2400,4800,9600)"
990 PRINT #1, P$ + "       <=== PARITY (N,E,O)"
1000 PRINT #1, D$ + "       <=== DATA BITS (7,8)"
1010 PRINT #1, S$ + "       <=== STOP BITS (0,1)"
1020 PRINT #1, CHR$(13) + CHR$(13)
1030 PRINT #1, "EDIT THIS FILE TO MATCH YOUR TNC SETTINGS."
1040 PRINT #1, "IF FILE IS CORRUPT, DELETE IT AND TNCset WILL CREATE ANOTHER."
1050 PRINT #1, "FOR MORE INFORMATION REFER TO THE DOCUMENTATION IN TNC.DOC."
1060 CLOSE #1: RETURN

